abuild.in 25.4 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
apkcache=@apkcache@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
SUDO=${SUDO:-"sudo"}
22
FAKEROOT=${FAKEROOT:-"fakeroot"}
23

Natanael Copa's avatar
Natanael Copa committed
24
# read config
Natanael Copa's avatar
Natanael Copa committed
25
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
26 27
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

28

Natanael Copa's avatar
Natanael Copa committed
29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60
#colors
if [ -n "$USE_COLORS" ]; then
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
fi	
	

# functions
msg() {
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	[ -z "$quiet" ] && printf "${prompt} ${name}${fake}: $@\n" >&2
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}
Natanael Copa's avatar
Natanael Copa committed
61 62

	
Linux User's avatar
Linux User committed
63 64
set_xterm_title() {
	if [ "$TERM" = xterm ]; then
65
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
66 67 68 69 70
	fi
} 

cleanup() {
	set_xterm_title ""
71
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
72
		$SUDO apk del $uninstall_after
73
	fi
Linux User's avatar
Linux User committed
74 75
}

Natanael Copa's avatar
Natanael Copa committed
76
die() {
Linux User's avatar
Linux User committed
77
	error "$@"
Linux User's avatar
Linux User committed
78
	cleanup
Natanael Copa's avatar
Natanael Copa committed
79 80 81
	exit 1
}

82 83
# check if apkbuild is basicly sane
sanitycheck() {
Natanael Copa's avatar
Natanael Copa committed
84
	local i
85
	msg "Checking sanity of $APKBUILD..."
86 87 88
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
89
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
Natanael Copa's avatar
Natanael Copa committed
90 91 92
		apk version --check -q "$pkgver" ||\
			die "$pkgver is not a valid version"
	fi
93 94 95 96 97
	[ -z "$pkgrel" ] && warning "Missing pkgrel in APKBUILD. Using pkgrel=0"
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

Natanael Copa's avatar
Natanael Copa committed
98 99 100 101 102 103 104
	for i in $install; do
		[ -e "$startdir/$i" ] || die "install script $startdir/$i is missing"
	done
	
	[ -n "${triggers%%:*}" ] && [ ! -e "$startdir"/${triggers%%:*} ] \
		&& die "trigger script $startdir/${triggers%%:*} is missing"

105 106
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
107 108 109 110
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
111
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
Natanael Copa's avatar
Natanael Copa committed
112 113 114
			case "$i" in
				https://*) makedepends_has wget || die "wget must be in makedepends when source has https://" ;;
			esac
115 116
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
117

118 119
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
Natanael Copa's avatar
Natanael Copa committed
120
			source_has $i || die "$i exists in md5sums but is missing in source"
121 122
		done
	fi
123

124 125 126
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
127 128

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
129 130

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
131 132 133 134
	return 0
}

md5check() {
Natanael Copa's avatar
Natanael Copa committed
135
	local dummy f
136 137 138
	if [ -z "$source" ]; then
		return 0
	fi
139
	if [ -z "$md5sums" ]; then
140
		die "Use 'abuild checksum' to generate/update the checksum(s)"
141
	fi
142 143 144
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
145
	fetch || return 1
146
	msg "Checking md5sums..."
147
	cd "$srcdir" && echo "$md5sums" | md5sum -c 
Natanael Copa's avatar
Natanael Copa committed
148 149 150 151
}

uri_fetch() {
	local uri="$1"
152
	local d="${uri##*/}"	# $(basename $uri)
153 154 155 156
	local opts
	[ -n "$quiet" ] && opts="-q"
	[ -f "$SRCDEST/$d" ] && return 0

Natanael Copa's avatar
Natanael Copa committed
157 158 159 160 161
	# we need GNU wget for this
	case "$uri" in
		https://*) opts="--no-check-certificate";;
	esac
	
Natanael Copa's avatar
Natanael Copa committed
162
	mkdir -p "$SRCDEST"
163 164 165
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
		opts="$opts -c"
Natanael Copa's avatar
Natanael Copa committed
166
	fi
Linux User's avatar
Linux User committed
167
	msg "Fetching $uri"
168 169
	wget $opts -O "$SRCDEST/$d.part" "$uri" \
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
Natanael Copa's avatar
Natanael Copa committed
170 171
}

172 173
is_remote() {
	case "$1" in
Natanael Copa's avatar
Natanael Copa committed
174
		http://*|ftp://*|https://*)
175 176 177 178 179
			return 0;;
	esac
	return 1
}

180 181 182 183 184 185 186 187 188 189
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	local d="${uri##*/}"	# $(basename $uri)
	if [ -n "$DISTFILES_MIRROR" ]; then
		uri_fetch "$DISTFILES_MIRROR"/$d && return 0
	fi
	uri_fetch "$uri"
}

190
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
191 192
	local s
	mkdir -p "$srcdir"
193 194
	for s in $source; do
		if is_remote "$s"; then
195
			uri_fetch_mirror "$s" || return 1
196 197 198 199
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
200 201 202
	done
}

203 204 205 206
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
207
# unpack the sources
208
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
209
	local u
210
	md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
211 212 213 214
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
215
			*.tar.gz|*.tgz)
216
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
217 218
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
219
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
220
				tar -C "$srcdir" -jxf "$s" || return 1;;
221 222 223 224
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
Natanael Copa's avatar
Natanael Copa committed
225 226 227
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
228 229 230 231
		esac
	done
}

232 233 234 235
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
236 237
# cleanup source and package dir
clean() {
238
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
239
	rm -rf "$srcdir"
240
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
241 242 243 244 245 246
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
247 248 249 250
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
251 252 253 254 255
	done
}

cleanpkg() {
	local i
256
	getpkgver || return 1
257
	msg "Cleaning built packages..."
258
	for i in $pkgname $subpackages; do
259 260
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
261
			"$apkcache"/$p.apk
Natanael Copa's avatar
Natanael Copa committed
262
	done
263
	# remove given packages from index
Natanael Copa's avatar
Natanael Copa committed
264 265
}

266 267 268
# clean all packages except current
cleanoldpkg() {
	local i j
269
	getpkgver || return 1
270 271 272 273 274 275 276 277 278
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
	for i in $pkgname $subpackages; do
		for j in "$PKGDEST"/${i%:*}-[0-9]*.apk; do
			[ "$j" != "$PKGDEST/${i%:*}-$pkgver-r$pkgrel.apk" ] \
				&& rm -f "$j"
		done
	done
	return 0
}
279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296

mkusers() {
	local i
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
			msg "Creating user $i"
			$SUDO adduser -D -H $i || return 1
		fi
	done
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$SUDO addgroup $i || return 1
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
297 298
runpart() {
	local part=$1
299
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
300 301 302 303
	$part || die "$part failed"
}

# override those in your build script
304 305 306 307 308 309 310 311
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
312 313 314 315
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
316
build() {
317
	:
Natanael Copa's avatar
Natanael Copa committed
318 319
}

320 321 322 323 324 325
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

Natanael Copa's avatar
Natanael Copa committed
326 327 328 329 330 331 332 333 334
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

335
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
336
	if [ -z "$subpackages" ]; then
337 338
		return 0
	fi
Natanael Copa's avatar
Natanael Copa committed
339 340
	local i
	cd "$startdir"
341
	for i in $subpackages; do
Natanael Copa's avatar
Natanael Copa committed
342 343
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
344
		msg "Running split function $func..."
345
		subpkgdir="$pkgbasedir/${i%:*}" subpkgname="${i%:*}" \
346
			$0 $func prepare_package || return 1
Natanael Copa's avatar
Natanael Copa committed
347 348 349
	done
}

350
prepare_metafiles() {
351
	getpkgver || return 1
352 353
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
354
	local dir=${subpkgdir:-$pkgdir}
355
	local pkg="$name-$pkgver-r$pkgrel.apk"
356
	local pkginfo="$controldir"/.PKGINFO
357
	local sub
Natanael Copa's avatar
Natanael Copa committed
358 359 360
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
361
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
362 363 364
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')

365
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
366
	if [ -n "$FAKEROOTKEY" ]; then
367
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
368
	fi
369 370
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
371
pkgname = $name
372
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
373 374 375 376 377 378
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
EOF
379 380
	local i deps
	deps="$depends"
381
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
Natanael Copa's avatar
Natanael Copa committed
382 383
		for i in $install ${triggers%%:*}; do
			if head -n 1 "$startdir/$i" | grep '^#!/bin/sh' >/dev/null ; then
384 385 386 387 388
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
389 390
	fi
	
Natanael Copa's avatar
Natanael Copa committed
391
	for i in $license; do
392
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
393 394
	done
	for i in $replaces; do
395
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
396
	done
397
	for i in $deps; do
398
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
399 400
	done
	for i in $conflicts; do
401
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
402 403
	done
	for i in $provides; do
404
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
405 406
	done
	for i in $backup; do
407
		echo "backup = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
408
	done
Natanael Copa's avatar
Natanael Copa committed
409 410 411
	if [ -n "$triggers" ]; then
		echo "triggers = ${triggers#*:}" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
412 413

	local metafiles=".PKGINFO"
Natanael Copa's avatar
Natanael Copa committed
414
	for i in $install ${triggers%%:*}; do
415 416
		script=${i#$name}
		case "$script" in
Natanael Copa's avatar
Natanael Copa committed
417
			.pre-install|.post-install|.pre-upgrade|.post-upgrade|.pre-deinstall|.post-deinstall|.trigger)
418 419
				msg "Adding $script"
				;;
Natanael Copa's avatar
Natanael Copa committed
420
			*) 	error "$script: Invalid install/trigger script"
421 422 423
				return 1
				;;
		esac
Natanael Copa's avatar
Natanael Copa committed
424
		cp "$startdir/$i" "$controldir/$script" || return 1
425
		chmod +x "$controldir/$script"
426 427
		metafiles="$metafiles $script"
	done
428
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
429
}
430

431 432 433
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
	options_has "!tracedeps" && return 0
434 435
	find -name '*.so' -o -name '*.so.[0-9]*' | sed 's:.*/::' \
		>"$controldir"/.provides-so
436
	scanelf -Rn "$dir" | awk -F "\ " '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
437 438 439
		| sed 's:,:\n:g' | sort | uniq \
	| while read i; do
		# only add files that are not self provided
440 441
		grep "^$i$" "$controldir"/.provides-so >/dev/null \
			|| echo $i >> "$controldir"/.needs-so
442
	done
Natanael Copa's avatar
Natanael Copa committed
443 444
}

445
prepare_package() {
446
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
447
	stripbin
448
	prepare_metafiles && prepare_tracedeps
449 450 451 452 453 454 455 456
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

457 458 459
trace_apk_deps() {
	local name="$1"
	local dir="$2"
460 461
	local i j found autodeps=
	msg "Tracing dependencies for $name..."
462 463 464 465 466 467
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
		msg "Added pkgconfig as dependency"
		echo "depend = pkgconfig" >> "$dir"/.PKGINFO
	fi
468
	for i in $(cat "$dir"/.needs-so 2>/dev/null); do
469
		found=
470
		# first check if its provide by same apkbuild
471
		for j in "$dir"/../.control.*/.provides-so; do
472
			grep -w "$i" "$j" >/dev/null || continue
473
			found=${j%/.provides-so}
474
			found=${found##*/.control.}
475
			break
476 477 478 479 480 481 482 483 484
		done
		# check apk db if not provided by a subpackage
		if [ -z "$found" ]; then
			found=$(apk info -q -W /lib/$i /usr/lib/$i)
		fi
		if [ -z "$found" ]; then
			error "Could not find dependency for $i"
			return 1
		fi
485
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
486 487 488
			warning "You can remove '$found' from depends"
			continue
		fi
489 490
		list_has "$found" $autodeps || autodeps="$autodeps $found"
		msg "Added '$found' as dependency as it has $i"
491 492 493 494 495 496 497 498
	done
	[ -z "$autodeps" ] && return 0
	echo "# automatically detected:" >> "$dir"/.PKGINFO
	for i in $autodeps; do
		echo "depend = $i" >> "$dir"/.PKGINFO
	done
}

499 500
create_apks() {
	local file
501
	getpkgver || return 1
502
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
503 504 505
		local dir="${file%/.PKGINFO}"
		local name=$(pkginfo_val pkgname $file)
		local ver=$(pkginfo_val pkgver $file)
506
		local apk=$name-$ver.apk
507
		local datadir="$pkgbasedir"/$name
508 509

		trace_apk_deps "$name" "$dir" || return 1
510
		msg "Creating $apk..."
511
		(
512 513
		cd "$datadir"
		# data.tar.gz
514 515 516 517 518 519
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
520 521 522 523 524 525

		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
526
		cd "$dir"
527 528
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
529
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
530

531 532 533
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
	)
534 535 536
	done
}

537
apkcache() {
538
	if ! apk_up2date || [ -n "$force" ]; then
539
		sanitycheck && builddeps && clean && fetch && unpack \
Natanael Copa's avatar
Natanael Copa committed
540
			&& prepare && mkusers && rootpkg || return 1
541
	fi
542

543
	local apk
544
	mkdir -p "$apkcache" || return 1
545 546 547 548 549 550 551 552 553 554
	cd "$apkcache"

	# remove broken links
	for apk in *.apk; do
		if [ -L "$apk" ] && [ ! -f "$apk" ]; then
			rm -f "$apk"
		fi
	done

	# create links for this package
555
	for apk in $(listpkg); do
556
		ln -sf "$PKGDEST"/$apk "$apkcache"/$apk
557 558
	done

559
	msg "Updating the cached abuild repository index..."
560 561 562 563 564
	local sign=".SIGN.RSA.${SIGN_PUBLIC_KEY##*/}"
	local oldindex=
	if [ -f APKINDEX.tar.gz ]; then
		oldindex="--index APKINDEX.tar.gz"
	fi
565 566 567
	apk index $oldindex --output APKINDEX.tar.gz.unsigned \
		--description "$repo $(cd $startdir && git describe)" \
		*.apk || exit 1
568 569 570
	msg "Signing the index..."
	abuild-sign -q APKINDEX.tar.gz.unsigned || exit 1
	mv APKINDEX.tar.gz.unsigned APKINDEX.tar.gz
Natanael Copa's avatar
Natanael Copa committed
571
	chmod 644 APKINDEX.tar.gz
572 573
}

574
# predefined splitfunc doc
575
default_doc() {
576
	depends="$depends_doc"
577
	install="$install_doc"
Natanael Copa's avatar
Natanael Copa committed
578
	triggers="$triggers_doc"
Natanael Copa's avatar
Natanael Copa committed
579
	local i
580
	for i in doc man info html sgml licenses gtk-doc; do
581 582 583
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
584 585
		fi
	done
586 587 588
	
	rm -f "$subpkgdir/usr/share/info/dir"

589 590 591
#	# compress info and man pages
#	find "$subpkgdir/usr/share" \( -name '*.info' -o -name '*.info-[1-9]' \
#		-o -name '*.[1-9]' \) -exec gzip {} \;
592 593 594 595

	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
596
#	[ -d "$subpkgdir/usr/share/man" ] && depends="man"
Natanael Copa's avatar
Natanael Copa committed
597 598 599
	return 0
}

600 601 602 603
doc() {
	default_doc
}

604
# predefined splitfunc mod
605
default_mod() {
606
	depends="$kernel $depends_mod"
607
	install="$install_mod"
Natanael Copa's avatar
Natanael Copa committed
608
	for i in firmware modules; do
609 610 611
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
612
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
613 614 615 616
		fi
	done
}

617 618 619 620
mod() {
	default_mod
}

621
# predefined splitfunc dev
622
default_dev() {
623
	local i
624
	depends="$pkgname $depends_dev"
625
	install="$install_dev"
Natanael Copa's avatar
Natanael Copa committed
626
	triggers="$triggers_dev"
627 628 629 630
	for i in $origsubpackages; do
		[ "${i%:*}" = "$subpkgname" ] || depends="$depends ${i%:*}"
	done
		
631
	cd "$pkgdir" || return 0
632 633 634 635 636
	for i in usr/include usr/lib/pkgconfig usr/share/aclocal\
			usr/share/gettext usr/bin/*-config	\
			$(find -name include -type d) 		\
			$(find usr/ -name '*.[acho]' -o -name '*.la' \
			2>/dev/null); do
637 638
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
639
			mkdir -p "$d"
640
			mv "$pkgdir/$i" "$d"
641
			rmdir "$pkgdir/${i%/*}" 2>/dev/null
Natanael Copa's avatar
Natanael Copa committed
642 643
		fi
	done
Natanael Copa's avatar
Natanael Copa committed
644
	return 0
Natanael Copa's avatar
Natanael Copa committed
645 646
}

647 648 649 650
dev() {
	default_dev
}

651 652 653 654
is_function() {
	type "$1" 2>&1 | head -n 1 | egrep -q "is a (shell )?function"
}

Natanael Copa's avatar
Natanael Copa committed
655 656
# build and package in fakeroot
rootpkg() {
657 658 659 660
	local do_build=build
	cd "$startdir"
	if is_function package; then
		build || return 1
661
		do_build=package
662
	fi
Natanael Copa's avatar
Natanael Copa committed
663
	cd "$startdir"
664 665 666 667
	[ -n "$FAKEROOT" ] && msg "Entering fakeroot..."
	$FAKEROOT "$abuild_path" $do_build \
		prepare_subpackages \
		prepare_package \
668
		create_apks
Natanael Copa's avatar
Natanael Copa committed
669 670 671
}

srcpkg() {
672
	getpkgver || return 1
673
	local p="$pkgname-$pkgver-$pkgrel"
Natanael Copa's avatar
Natanael Copa committed
674
	local prefix="${startdir##*/}"
Natanael Copa's avatar
Natanael Copa committed
675 676 677 678 679
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
680
	msg "Creating source package $p.src.tar.gz..."
681
	(cd .. && tar -zcf "$PKGDEST/$p.src.tar.gz" $files) 
Natanael Copa's avatar
Natanael Copa committed
682 683
}

684
# check if package is up to date
685
apk_up2date() {
686
	getpkgver || return 1
687
	local pkg="$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk"
688
	local i s
Natanael Copa's avatar
Natanael Copa committed
689
	cd "$startdir"
690 691 692 693 694
	for i in $pkgname $subpackages; do
		[ -f "$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk" ] || return 1
	done
	[ -n "$keep" ] && return 0

695
	for i in $source APKBUILD; do
696 697 698 699 700 701
		local s
		if is_remote "$i"; then
			s="$SRCDEST/${i##*/}"	# $(basename $i)
		else
			s="$startdir/${i##*/}"
		fi
702 703 704 705 706 707 708
		if [ "$s" -nt "$pkg" ]; then
			return 1
		fi
	done
	return 0
}

709 710
cache_up2date() {
	local i apk
711
	getpkgver || return 1
712 713
	for i in $pkgname $subpackages; do
		apk="${i%:*}-$pkgver-r$pkgrel.apk"
714
		[ "$apkcache"/APKINDEX.tar.gz -nt "$apkcache"/$apk ] || return 1
715 716 717 718 719 720 721 722
	done
	return 0
}

up2date() {
	apk_up2date && cache_up2date
}

723 724 725 726 727 728 729
# source all APKBUILDs and output:
#  1) origin of package
#  2) all dependencies
# the output is i in a format easy parseable for awk
depparse_aports() {
	# lets run this in a subshell since we source all APKBUILD here
	(
730 731
	aportsdir=$(realpath ${APKBUILD%/APKBUILD}/..)
	for i in $aportsdir/*/APKBUILD; do
732 733 734 735
		pkgname=
		subpackages=
		depends=
		makedepends=
736
		. $i
737
		dir=${i%/APKBUILD}
738
		deps=
739
		# filter out conflicts from deps and version info
740 741 742 743
		for j in $depends $makedepends; do
			case "$j" in
				!*) continue;;
			esac
744
			deps="$deps ${j%[<>=]*}"
745
		done
746
		for j in $pkgname $subpackages; do
747
			echo "o ${j%%:*} $dir"
748
			set -- $deps
749 750 751 752 753 754 755
			echo -n "d ${j%%:*} $1"
			shift
			while [ $# -gt 0 ]; do
				echo -n ",$1"
				shift
			done
			echo
756 757
		done
	done
758
	)
759 760
}

761
deptrace() {
762 763 764 765 766
	local deps= i=
	# strip versions from deps
	for i in "$@"; do
		deps="$deps ${i%[<>=]*}"
	done
767
	[ -z "$deps" ] && return 0
768 769 770
	( 	depparse_aports 
		if [ -z "$upgrade" ]; then
			# list installed pkgs and prefix with 'i '
Natanael Copa's avatar
abuild:  
Natanael Copa committed
771
			apk info -q | sort |  sed 's/^/i /'
772
		fi
773
	) | awk -v pkgs="$deps" '
774 775 776 777 778 779 780 781 782 783 784 785 786 787 788 789 790 791 792 793 794 795 796 797 798

	function depgraph(pkg,	a, i) {
		if (visited[pkg])
			return 0;
		visited[pkg] = 1;
		split(deps[pkg], a, ",");
		for (i in a)
			depgraph(a[i]);
		print pkg ":" origin[pkg];

	}

	$1 == "i" { visited[$2] = 1 }
	$1 == "o" { origin[$2] = $3 }
	$1 == "d" { deps[$2] = $3 }
	END {
		split(pkgs, pkgarray);
		for (i in pkgarray)
			depgraph(pkgarray[i]);
	}
	'
}

# build and install dependencies
builddeps() {
799 800
	local deps= alldeps= pkg= i= dir= ver= missing= installed_deps=
	local filtered_deps=
801
	[ -n "$nodeps" ] && return 0
802
	msg "Analyzing dependencies..."
803 804 805 806
	deps="$BUILD_BASE $makedepends"

	# add depends unless it is a subpackage
	for i in $depends; do
807
		subpackages_has ${i%[<>=]*} || deps="$deps $i"
808 809
	done

810
	installed_deps=$(apk info -e $deps)
811
	# find which deps are missing
812
	for i in $deps; do
813
		if [ "${i#\!}" != "$i" ]; then
814
			list_has ${i#\!} $installed_deps \
815
				&& die "Conflicting package ${i#\!} is installed."
816
		elif ! deplist_has $i $installed_deps; then
817 818 819 820 821 822 823
			if [ -z "$install_deps" ] && [ -z "$recursive" ]; then
				die "Missing dependency $i. Use -r to autoinstall or -R to build"
			fi
			missing="$missing $i"
		fi
	done

824 825
	[ -z "$missing" ] && [ -z "$install_deps" ] && [ -z "$recursive" ] \
		&& return 0
826

827
	uninstall_after=".makedepends-$pkgname $uninstall_after"
828
	if [ -n "$install_deps" ] && [ -z "$recursive" ]; then
829 830
		# make a --simluate run first to detect missing deps
		# apk-tools --virtual is no goot at reporting those.
831
		$SUDO apk add --repository "$apkcache" \
832 833 834 835
			--wait 30 \
			--simulate --quiet $deps || return 1
		$SUDO apk add --repository "$apkcache" \
			--wait 30 \
836 837
			--virtual .makedepends-$pkgname $deps \
			&& return 0
838
	fi
839 840
	
	[ -z "$recursive" ] && return 1
841 842 843

	# find dependencies that are installed but missing in repo.
	for i in $deps; do
844
		local m=$(apk search --repository "$apkcache" ${i%[<>=]*})
Natanael Copa's avatar
Natanael Copa committed
845
		if [ -z "$m" ]; then
846 847 848
			missing="$missing $i"
		fi
	done
849 850
	
	for i in $(deptrace $missing); do
851 852 853 854
		# i = pkg:dir
		local dir=${i#*:}
		local pkg=${i%:*}
		msg "Entering $dir"
855
		cd "$dir" && $0 -k -r apkcache || return 1
856
	done
857
	$SUDO apk add -u --repository "$apkcache" \
858
		--wait 30 \
859
		--virtual .makedepends-$pkgname $deps
860 861
}

862
# replace the md5sums in the APKBUILD
Natanael Copa's avatar
Natanael Copa committed
863 864
checksum() {
	local s files
865
	[ -z "$source" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
866
	fetch
867
	msg "Updating the md5sums in APKBUILD..."
Natanael Copa's avatar
Natanael Copa committed
868 869 870 871
	for s in $source; do
		files="$files ${s##*/}"
	done
	md5sums="$(cd "$srcdir" && md5sum $files)" || die "md5sum failed"
872 873
	sed -i -e '/^md5sums="/,/"\$/d; /^md5sums=''/,/''\$/d' "$APKBUILD"
	echo "md5sums=\"$md5sums\"" >>"$APKBUILD"
Natanael Copa's avatar
Natanael Copa committed
874 875
}

876
stripbin() {
877
	local bin
878
	options_has "!strip" && return 0
879 880
	cd "${subpkgdir:-$pkgdir}" || return 1
	msg "Stripping binaries"
881 882 883
	scanelf --recursive --nobanner --etype "ET_DYN,ET_EXEC" . \
		| sed -e 's:^ET_DYN ::' -e 's:^ET_EXEC ::' \
		| xargs -r strip
884 885
}

886 887 888
# simply list target apks
listpkg() {
	local i 
889
	getpkgver || return 1
890 891 892 893 894
	for i in $pkgname $subpackages; do
		echo "${i%:*}-$pkgver-r$pkgrel.apk"
	done
}

Natanael Copa's avatar
Natanael Copa committed
895 896 897 898 899 900 901 902
source_has() {
	local i
	for i in $source; do
		[ "$1" = "${i##*/}" ] && return 0
	done
	return 1
}

Natanael Copa's avatar
abuild:  
Natanael Copa committed
903 904 905 906 907 908 909 910
subpackages_has() {
	local i
	for i in $subpackages; do
		[ "$1" = "${i%:*}" ] && return 0
	done
	return 1
}

911 912 913 914 915 916 917 918 919 920 921
list_has() {
	local needle="$1"
	local i
	shift
	for i in $@; do
		[ "$needle" = "$i" ] && return 0
		[ "$needle" = "!$i" ] && return 1
	done
	return 1
}

922 923 924 925 926 927 928 929 930 931 932 933 934
# same as list_has but we filter version info
deplist_has() {
	local needle="$1"
	local i
	shift
	for i in $@; do
		i=${i%[<>=]*}
		[ "$needle" = "$i" ] && return 0
		[ "$needle" = "!$i" ] && return 1
	done
	return 1
}

935 936 937 938
options_has() {
	list_has "$1" $options
}

939
depends_has() {
940
	deplist_has "$1" $depends
941 942
}

Natanael Copa's avatar
Natanael Copa committed
943
makedepends_has() {
944
	deplist_has "$1" $makedepends
Natanael Copa's avatar
Natanael Copa committed
945 946
}

Natanael Copa's avatar
Natanael Copa committed
947 948 949 950
md5sums_has() {
	list_has "$1" $md5sums
}

Natanael Copa's avatar
Natanael Copa committed
951 952 953 954
install_has() {
	list_has "$1" $install
}

Natanael Copa's avatar
abuild:  
Natanael Copa committed
955 956
# install package after build
post_add() {
957
	getpkgver || return 1
Natanael Copa's avatar
abuild:  
Natanael Copa committed
958 959 960 961 962 963 964 965 966 967 968 969
	local pkgf="$PKGDEST/$1-$pkgver-r$pkgrel.apk"
	local deps i
	if ! subpackages_has $1 && [ "$1" != "$pkgname" ]; then
		die "$1 is not built by this APKBUILD"
	fi
	# recursively install dependencies that are provided by this APKBUILD
	deps=$(apk index "$pkgf" 2>/dev/null | awk -F: '$1=="D" { print $2 }')
	for i in $deps; do
		if subpackages_has $i || [ "$i" = "$pkgname" ]; then
			post_add $i || return 1
		fi
	done
970
	$SUDO apk add --wait 30 -u "$pkgf" || die "Failed to install $1"
Natanael Copa's avatar
abuild:  
Natanael Copa committed
971 972
}

973
installdeps() {
974
	local deps i
975 976
	sudo apk add --wait 30 --repository "$apkcache" \
		--virtual .makedepends-$pkgname \
977
		$makedepends
978 979 980
}

uninstalldeps (){
981
	sudo apk del .makedepends-$pkgname
982
}
983 984 985 986 987 988 989 990 991

all() {
	if up2date && [ -z "$force" ]; then
		msg "Package is up to date"
	else
		apkcache
	fi
}

Natanael Copa's avatar
Natanael Copa committed
992
usage() {
993 994
	echo "$program $abuild_ver"
	echo "usage: $program [options] [-i PKG] [-P REPODEST] [-p PKGDEST]"
995
	echo "              [-s SRCDEST] [cmd] ..."
996
	echo "       $program [-c] -n PKGNAME[-PKGVER]"
Natanael Copa's avatar
Natanael Copa committed
997
	echo "Options:"
998
	echo " -d  Disable dependency checking"
Natanael Copa's avatar
Natanael Copa committed
999
	echo " -f  Force specified cmd, even if they are already done"
1000
	echo " -F  Force run as root"
1001 1002
	echo " -h  Show this help"
	echo " -i  Install PKG after successul build"
1003
	echo " -k  Keep built packages, even if APKBUILD or sources are newer"
1004
	echo " -p  Set package destination directory"
1005
	echo " -P  Set PKGDEST to REPODEST/<repo>, where repo is the parents dir name" 
Natanael Copa's avatar
Natanael Copa committed
1006
	echo " -q  Quiet"
1007 1008
	echo " -r  Install missing dependencies from system repository (using sudo)"
	echo " -R  Recursively build and install missing dependencies (using sudo)"
1009
	echo " -s  Set source package destination directory"
1010
	echo " -u  Recursively build and upgrade all dependencies (using sudo)"
Natanael Copa's avatar
Natanael Copa committed
1011 1012
	echo ""
	echo "Commands:"
1013
	echo "  checksum    Generate checksum to be included in APKBUILD"
1014 1015 1016 1017 1018
	echo "  fetch       Fetch sources to \$SRCDEST and verify checksums"
	echo "  sanitycheck Basic sanity check of APKBUILD"
	echo "  md5check    Check md5sums"
	echo "  unpack      Unpack sources to \$srcdir"
	echo "  build       Compile and install package into \$pkgdir"
1019
	echo "  listpkg     List target packages"
1020 1021 1022
	echo "  package     Create package in \$PKGDEST"
	echo "  rootpkg     Run '$0 build package' as fakeroot"
	echo "  clean       Remove temp build and install dirs"
1023
	echo "  cleanoldpkg Remove binary packages except current version"
1024 1025 1026 1027
	echo "  cleanpkg    Remove already built binary and source package"
	echo "  cleancache  Remove downloaded files from \$SRCDEST"
	echo "  srcpkg      Make a source package"
	echo "  up2date     Compare target and sources dates"
1028 1029
	echo "  installdeps Install packages listed in makedepends and depends"
	echo "  uninstalldeps Uninstall packages listed in makedepends and depends"
Natanael Copa's avatar
Natanael Copa committed
1030 1031 1032 1033 1034
	echo ""
	exit 0
}

APKBUILD="${APKBUILD:-./APKBUILD}"
1035 1036
unset force
unset recursive
1037
while getopts "dfFhi:kinp:P:qrRs:u" opt; do
Natanael Copa's avatar
Natanael Copa committed
1038
	case $opt in
1039
		'd') nodeps=1;;
Natanael Copa's avatar
Natanael Copa committed
1040
		'f') force=1;;
1041
		'F') forceroot=1;;
1042 1043
		'h') usage;;
		'i') install_after="$install_after $OPTARG";;
1044
		'k') keep=1;;
1045
		'n') die "Use newapkbuild to create new aports";;
1046
		'p') PKGDEST=$OPTARG;;
1047
		'P') REPODEST=$OPTARG;;
Natanael Copa's avatar
Natanael Copa committed
1048
		'q') quiet=1;;
1049 1050
		'r') install_deps=1;;
		'R') recursive=1;;
1051
		's') SRCDEST=$OPTARG;;
1052 1053
		'u') upgrade=1
		     recursive=1;;
Natanael Copa's avatar
Natanael Copa committed
1054 1055 1056 1057
	esac
done
shift $(( $OPTIND - 1 ))

1058 1059 1060 1061 1062 1063 1064
# check so we are not root
if [ "$(whoami)" = "root" ] && [ -z "$FAKEROOTKEY" ]; then
	[ -z "$forceroot" ] && die "Do not run abuild as root"
	SUDO=
	FAKEROOT=
fi

1065 1066 1067 1068 1069 1070 1071 1072 1073 1074 1075 1076 1077 1078 1079 1080 1081
# find startdir
[ -f "$APKBUILD" ] || die "Could not find $APKBUILD (PWD=$PWD)"
APKBUILD=$(readlink -f "$APKBUILD")

startdir="${APKBUILD%/*}"
srcdir=${srcdir:-"$startdir/src"}
pkgbasedir=${pkgbasedir:-"$startdir/pkg"}
pkgrel=0
repo=${startdir%/*}
repo=${repo##*/}

SRCDEST=${SRCDEST:-$startdir}
PKGDEST=${PKGDEST:-$startdir}

cd "$startdir" || die
. "$APKBUILD"

1082 1083 1084 1085 1086
# If REPODEST is set then it will override the PKGDEST
if [ -n "$REPODEST" ]; then
	PKGDEST="$REPODEST/$repo"
fi

1087
# If we are handling a sub package then reset subpackages and install
1088
if [ -n "$subpkgname" ]; then
1089
	origsubpackages="$subpackages"
1090
	subpackages=
1091
	install=
1092
fi
1093
pkgdir="$pkgbasedir/$pkgname"
1094
controldir="$pkgbasedir"/.control.${subpkgname:-$pkgname}
Natanael Copa's avatar
Natanael Copa committed
1095 1096

trap 'die "Aborted by user"' INT
Linux User's avatar
Linux User committed
1097
set_xterm_title "abuild: $pkgname"
Natanael Copa's avatar
Natanael Copa committed
1098 1099

if [ -z "$1" ]; then
1100
	set all
Natanael Copa's avatar
Natanael Copa committed
1101 1102 1103 1104 1105 1106
fi

while [ $# -gt 0 ]; do
	runpart $1
	shift
done
1107 1108

for i in $install_after; do
Natanael Copa's avatar
abuild:  
Natanael Copa committed
1109
	post_add $i